// $ANTLR 2.7.7 (2006-11-01): "CTypeEvaluator.g" -> "CTypeEvaluator.java"$

// This file is part of the program FRYSK.
//
// Copyright 2008 Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.
    package frysk.expr;

    import frysk.value.ArithmeticType;
    import frysk.value.SignedType;
    import frysk.value.PointerType;
    import frysk.value.CharType;
    // import frysk.value.ArrayType;
    import frysk.value.FloatingPointType;
    import frysk.value.CompositeType;
    // import frysk.value.Value;
    import frysk.value.Type;
    import frysk.expr.ExprSymTab;
    import inua.eio.ByteOrder;

// import antlr.TreeParser;
// import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
// import antlr.ANTLRException;
import antlr.NoViableAltException;
// import antlr.MismatchedTokenException;
// import antlr.SemanticException;
// import antlr.collections.impl.BitSet;
// import antlr.ASTPair;
// import antlr.collections.impl.ASTArray;


public class CTypeEvaluator extends antlr.TreeParser       implements CTypeEvaluatorTokenTypes
 {

    ArithmeticType longType;
    ArithmeticType intType;
    ArithmeticType shortType;
    FloatingPointType doubleType;
    FloatingPointType floatType;
    CharType charType;
    PointerType charPointerType;
    private ExprSymTab exprSymTab;

    public CTypeEvaluator(ExprSymTab symTab) {
	    exprSymTab = symTab;
        shortType = new SignedType("short", ByteOrder.LITTLE_ENDIAN, 2);
        intType = new SignedType("int", ByteOrder.LITTLE_ENDIAN, 4);
        longType = new SignedType("long", ByteOrder.LITTLE_ENDIAN, exprSymTab.getWordSize());
        floatType = new FloatingPointType("float", ByteOrder.LITTLE_ENDIAN, 4);
        doubleType = new FloatingPointType("double", ByteOrder.LITTLE_ENDIAN, 8);
        charType = new CharType("char", ByteOrder.LITTLE_ENDIAN, 1, true);
        charPointerType = new PointerType("char*", ByteOrder.LITTLE_ENDIAN, 
                                          exprSymTab.getWordSize(), charType);
    }
public CTypeEvaluator() {
	tokenNames = _tokenNames;
}

	public final void primitiveType(AST _t) throws RecognitionException {
		
		AST primitiveType_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_boolean:
			{
				AST tmp1_AST_in = (AST)_t;
				match(_t,LITERAL_boolean);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_char:
			{
				AST tmp2_AST_in = (AST)_t;
				match(_t,LITERAL_char);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_byte:
			{
				AST tmp3_AST_in = (AST)_t;
				match(_t,LITERAL_byte);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_short:
			{
				AST tmp4_AST_in = (AST)_t;
				match(_t,LITERAL_short);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_int:
			{
				AST tmp5_AST_in = (AST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_long:
			{
				AST tmp6_AST_in = (AST)_t;
				match(_t,LITERAL_long);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_float:
			{
				AST tmp7_AST_in = (AST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_double:
			{
				AST tmp8_AST_in = (AST)_t;
				match(_t,LITERAL_double);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final String  identifier(AST _t) throws RecognitionException {
		String idSpelling=null;
		
		AST identifier_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST ident = null;
		
		try {      // for error handling
			ident = (AST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				idSpelling=ident.getText();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return idSpelling;
	}
	
	public final Type  type(AST _t) throws RecognitionException {
		Type returnVar=null;
		
		AST type_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST pt = null;
		AST ident = null;
		AST tident = null;
		Type t1, t2, t3; String s1;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PLUS:
			case STAR:
			case DIVIDE:
			case MOD:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case PLUS:
				{
					AST __t5 = _t;
					AST tmp9_AST_in = (AST)_t;
					match(_t,PLUS);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t5;
					_t = _t.getNextSibling();
					break;
				}
				case STAR:
				{
					AST __t6 = _t;
					AST tmp10_AST_in = (AST)_t;
					match(_t,STAR);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t6;
					_t = _t.getNextSibling();
					break;
				}
				case DIVIDE:
				{
					AST __t7 = _t;
					AST tmp11_AST_in = (AST)_t;
					match(_t,DIVIDE);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t7;
					_t = _t.getNextSibling();
					break;
				}
				case MOD:
				{
					AST __t8 = _t;
					AST tmp12_AST_in = (AST)_t;
					match(_t,MOD);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t8;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
						
					returnVar = t1.getALU(t2,
					exprSymTab.getWordSize())
					.getResultType();  
					
				}
				break;
			}
			case BITWISEOR:
			case BITWISEXOR:
			case AMPERSAND:
			case SHIFTLEFT:
			case SHIFTRIGHT:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case SHIFTLEFT:
				{
					AST __t15 = _t;
					AST tmp13_AST_in = (AST)_t;
					match(_t,SHIFTLEFT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t15;
					_t = _t.getNextSibling();
					break;
				}
				case SHIFTRIGHT:
				{
					AST __t16 = _t;
					AST tmp14_AST_in = (AST)_t;
					match(_t,SHIFTRIGHT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t16;
					_t = _t.getNextSibling();
					break;
				}
				case AMPERSAND:
				{
					AST __t17 = _t;
					AST tmp15_AST_in = (AST)_t;
					match(_t,AMPERSAND);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t17;
					_t = _t.getNextSibling();
					break;
				}
				case BITWISEXOR:
				{
					AST __t18 = _t;
					AST tmp16_AST_in = (AST)_t;
					match(_t,BITWISEXOR);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t18;
					_t = _t.getNextSibling();
					break;
				}
				case BITWISEOR:
				{
					AST __t19 = _t;
					AST tmp17_AST_in = (AST)_t;
					match(_t,BITWISEOR);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t19;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					returnVar = t1.getALU(t2, 
					exprSymTab.getWordSize())
					.getResultType();  
					
				}
				break;
			}
			case OR:
			case AND:
			case NOT:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case AND:
				{
					AST __t21 = _t;
					AST tmp18_AST_in = (AST)_t;
					match(_t,AND);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t21;
					_t = _t.getNextSibling();
					break;
				}
				case OR:
				{
					AST __t22 = _t;
					AST tmp19_AST_in = (AST)_t;
					match(_t,OR);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t22;
					_t = _t.getNextSibling();
					break;
				}
				case NOT:
				{
					AST __t23 = _t;
					AST tmp20_AST_in = (AST)_t;
					match(_t,NOT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t23;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					returnVar = t1.getALU(exprSymTab.getWordSize())
					.getIntResultType(); 
					
				}
				break;
			}
			case NOTEQUAL:
			case EQUAL:
			case LESSTHAN:
			case GREATERTHAN:
			case LESSTHANOREQUALTO:
			case GREATERTHANOREQUALTO:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LESSTHAN:
				{
					AST __t25 = _t;
					AST tmp21_AST_in = (AST)_t;
					match(_t,LESSTHAN);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t25;
					_t = _t.getNextSibling();
					break;
				}
				case GREATERTHAN:
				{
					AST __t26 = _t;
					AST tmp22_AST_in = (AST)_t;
					match(_t,GREATERTHAN);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t26;
					_t = _t.getNextSibling();
					break;
				}
				case LESSTHANOREQUALTO:
				{
					AST __t27 = _t;
					AST tmp23_AST_in = (AST)_t;
					match(_t,LESSTHANOREQUALTO);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t27;
					_t = _t.getNextSibling();
					break;
				}
				case GREATERTHANOREQUALTO:
				{
					AST __t28 = _t;
					AST tmp24_AST_in = (AST)_t;
					match(_t,GREATERTHANOREQUALTO);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t28;
					_t = _t.getNextSibling();
					break;
				}
				case EQUAL:
				{
					AST __t29 = _t;
					AST tmp25_AST_in = (AST)_t;
					match(_t,EQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t29;
					_t = _t.getNextSibling();
					break;
				}
				case NOTEQUAL:
				{
					AST __t30 = _t;
					AST tmp26_AST_in = (AST)_t;
					match(_t,NOTEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t30;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					returnVar = t1.getALU(t2, 
					exprSymTab.getWordSize())
					.getIntResultType();  
					
				}
				break;
			}
			case ADDRESS_OF:
			{
				AST __t31 = _t;
				AST tmp27_AST_in = (AST)_t;
				match(_t,ADDRESS_OF);
				_t = _t.getFirstChild();
				t1=type(_t);
				_t = _retTree;
				_t = __t31;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					PointerType pointerType = new PointerType
					("*", ByteOrder.LITTLE_ENDIAN, 
					exprSymTab.getWordSize(), t1);
					returnVar = pointerType;
					
				}
				break;
			}
			case MEMORY:
			{
				AST __t32 = _t;
				AST tmp28_AST_in = (AST)_t;
				match(_t,MEMORY);
				_t = _t.getFirstChild();
				t1=type(_t);
				_t = _retTree;
				_t = __t32;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((PointerType)t1).getType();
					
				}
				break;
			}
			case ARITHMETIC_PLUS:
			case ARITHMETIC_MINUS:
			case TILDE:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case TILDE:
				{
					AST __t34 = _t;
					AST tmp29_AST_in = (AST)_t;
					match(_t,TILDE);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t34;
					_t = _t.getNextSibling();
					break;
				}
				case ARITHMETIC_PLUS:
				{
					AST __t35 = _t;
					AST tmp30_AST_in = (AST)_t;
					match(_t,ARITHMETIC_PLUS);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t35;
					_t = _t.getNextSibling();
					break;
				}
				case ARITHMETIC_MINUS:
				{
					AST __t36 = _t;
					AST tmp31_AST_in = (AST)_t;
					match(_t,ARITHMETIC_MINUS);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t36;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					returnVar = t1;
					
				}
				break;
			}
			case PREINCREMENT:
			case PREDECREMENT:
			case POSTINCREMENT:
			case POSTDECREMENT:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case PREINCREMENT:
				{
					AST __t38 = _t;
					AST tmp32_AST_in = (AST)_t;
					match(_t,PREINCREMENT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t38;
					_t = _t.getNextSibling();
					break;
				}
				case PREDECREMENT:
				{
					AST __t39 = _t;
					AST tmp33_AST_in = (AST)_t;
					match(_t,PREDECREMENT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t39;
					_t = _t.getNextSibling();
					break;
				}
				case POSTINCREMENT:
				{
					AST __t40 = _t;
					AST tmp34_AST_in = (AST)_t;
					match(_t,POSTINCREMENT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t40;
					_t = _t.getNextSibling();
					break;
				}
				case POSTDECREMENT:
				{
					AST __t41 = _t;
					AST tmp35_AST_in = (AST)_t;
					match(_t,POSTDECREMENT);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t41;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					returnVar = t1; 
					
				}
				break;
			}
			case COND_EXPR:
			{
				AST __t42 = _t;
				AST tmp36_AST_in = (AST)_t;
				match(_t,COND_EXPR);
				_t = _t.getFirstChild();
				t3=type(_t);
				_t = _retTree;
				t1=type(_t);
				_t = _retTree;
				t2=type(_t);
				_t = _retTree;
				_t = __t42;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					// FIXME: Is this a good enough estimate of result
					// type without actually evaluating conditional
					// expressions?
					returnVar = (t1.getSize()> t2.getSize())? t1:t2;
					
				}
				break;
			}
			case OCTALINT:
			{
				AST tmp37_AST_in = (AST)_t;
				match(_t,OCTALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = longType;
					
				}
				break;
			}
			case DECIMALINT:
			{
				AST tmp38_AST_in = (AST)_t;
				match(_t,DECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = longType;
					
				}
				break;
			}
			case HEXADECIMALINT:
			{
				AST tmp39_AST_in = (AST)_t;
				match(_t,HEXADECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = longType;
					
				}
				break;
			}
			case FLOAT:
			{
				AST tmp40_AST_in = (AST)_t;
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = floatType;
					
				}
				break;
			}
			case DOUBLE:
			{
				AST tmp41_AST_in = (AST)_t;
				match(_t,DOUBLE);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = doubleType;
					
				}
				break;
			}
			case ASSIGNEQUAL:
			case TIMESEQUAL:
			case DIVIDEEQUAL:
			case MINUSEQUAL:
			case PLUSEQUAL:
			case MODEQUAL:
			case SHIFTLEFTEQUAL:
			case SHIFTRIGHTEQUAL:
			case BITWISEANDEQUAL:
			case BITWISEXOREQUAL:
			case BITWISEOREQUAL:
			{
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case ASSIGNEQUAL:
				{
					AST __t44 = _t;
					AST tmp42_AST_in = (AST)_t;
					match(_t,ASSIGNEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t44;
					_t = _t.getNextSibling();
					break;
				}
				case PLUSEQUAL:
				{
					AST __t45 = _t;
					AST tmp43_AST_in = (AST)_t;
					match(_t,PLUSEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t45;
					_t = _t.getNextSibling();
					break;
				}
				case MINUSEQUAL:
				{
					AST __t46 = _t;
					AST tmp44_AST_in = (AST)_t;
					match(_t,MINUSEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t46;
					_t = _t.getNextSibling();
					break;
				}
				case TIMESEQUAL:
				{
					AST __t47 = _t;
					AST tmp45_AST_in = (AST)_t;
					match(_t,TIMESEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t47;
					_t = _t.getNextSibling();
					break;
				}
				case DIVIDEEQUAL:
				{
					AST __t48 = _t;
					AST tmp46_AST_in = (AST)_t;
					match(_t,DIVIDEEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t48;
					_t = _t.getNextSibling();
					break;
				}
				case MODEQUAL:
				{
					AST __t49 = _t;
					AST tmp47_AST_in = (AST)_t;
					match(_t,MODEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t49;
					_t = _t.getNextSibling();
					break;
				}
				case SHIFTLEFTEQUAL:
				{
					AST __t50 = _t;
					AST tmp48_AST_in = (AST)_t;
					match(_t,SHIFTLEFTEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t50;
					_t = _t.getNextSibling();
					break;
				}
				case SHIFTRIGHTEQUAL:
				{
					AST __t51 = _t;
					AST tmp49_AST_in = (AST)_t;
					match(_t,SHIFTRIGHTEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t51;
					_t = _t.getNextSibling();
					break;
				}
				case BITWISEANDEQUAL:
				{
					AST __t52 = _t;
					AST tmp50_AST_in = (AST)_t;
					match(_t,BITWISEANDEQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t52;
					_t = _t.getNextSibling();
					break;
				}
				case BITWISEXOREQUAL:
				{
					AST __t53 = _t;
					AST tmp51_AST_in = (AST)_t;
					match(_t,BITWISEXOREQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t53;
					_t = _t.getNextSibling();
					break;
				}
				case BITWISEOREQUAL:
				{
					AST __t54 = _t;
					AST tmp52_AST_in = (AST)_t;
					match(_t,BITWISEOREQUAL);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t54;
					_t = _t.getNextSibling();
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				if ( inputState.guessing==0 ) {
					
					returnVar = t1;
					
				}
				break;
			}
			case CAST:
			{
				AST __t55 = _t;
				AST tmp53_AST_in = (AST)_t;
				match(_t,CAST);
				_t = _t.getFirstChild();
				pt = _t==ASTNULL ? null : (AST)_t;
				primitiveType(_t);
				_t = _retTree;
				t2=type(_t);
				_t = _retTree;
				_t = __t55;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
						      if(pt.getText().compareTo("long") == 0) {
						        returnVar = longType;
						      }
						      else if(pt.getText().compareTo("int") == 0) {
						         returnVar = intType;
						      }
						      else if(pt.getText().compareTo("short") == 0) {
						         returnVar = shortType;
						      }
						      else if(pt.getText().compareTo("double") == 0) {
						         returnVar = doubleType;
						      }
						      else if(pt.getText().compareTo("float") == 0) {
						         returnVar = floatType;
						      }
						      // XXX: Implement casts for other pointer types as well
						      else if(t2.getName().compareTo("*") ==  0) {
						        if (pt.getText().compareTo("char") == 0) {	  
						          returnVar = charPointerType;
						        }
					}
					
				}
				break;
			}
			case EXPR_LIST:
			{
				AST __t56 = _t;
				AST tmp54_AST_in = (AST)_t;
				match(_t,EXPR_LIST);
				_t = _t.getFirstChild();
				t3=type(_t);
				_t = _retTree;
				_t = __t56;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = t3;
					
				}
				break;
			}
			case SIZEOF:
			{
				AST __t57 = _t;
				AST tmp55_AST_in = (AST)_t;
				match(_t,SIZEOF);
				_t = _t.getFirstChild();
				t1=type(_t);
				_t = _retTree;
				_t = __t57;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = longType; 
					
				}
				break;
			}
			case INDEX:
			{
				AST __t58 = _t;
				AST tmp56_AST_in = (AST)_t;
				match(_t,INDEX);
				_t = _t.getFirstChild();
				t1=type(_t);
				_t = _retTree;
				t2=type(_t);
				_t = _retTree;
				_t = __t58;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = t1.getType();
					
				}
				break;
			}
			case SLICE:
			{
				AST __t59 = _t;
				AST tmp57_AST_in = (AST)_t;
				match(_t,SLICE);
				_t = _t.getFirstChild();
				t1=type(_t);
				_t = _retTree;
				t2=type(_t);
				_t = _retTree;
				t3=type(_t);
				_t = _retTree;
				_t = __t59;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = t1.getSliceType();
					
				}
				break;
			}
			case MEMBER:
			{
				AST __t60 = _t;
				AST tmp58_AST_in = (AST)_t;
				match(_t,MEMBER);
				_t = _t.getFirstChild();
				t1=type(_t);
				_t = _retTree;
				s1=identifier(_t);
				_t = _retTree;
				_t = __t60;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((CompositeType)t1).getMemberType(s1);
					
				}
				break;
			}
			case IDENT:
			{
				ident = (AST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((Type)exprSymTab.getValue(ident.getText()).getType());
					
				}
				break;
			}
			case TAB_IDENT:
			{
				tident = (AST)_t;
				match(_t,TAB_IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((Type)exprSymTab.getValue(tident.getText()).getType());
					
				}
				break;
			}
			default:
				boolean synPredMatched11 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==MINUS))) {
					AST __t11 = _t;
					synPredMatched11 = true;
					inputState.guessing++;
					try {
						{
						AST __t10 = _t;
						AST tmp59_AST_in = (AST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						type(_t);
						_t = _retTree;
						type(_t);
						_t = _retTree;
						_t = __t10;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched11 = false;
					}
					_t = __t11;
inputState.guessing--;
				}
				if ( synPredMatched11 ) {
					AST __t12 = _t;
					AST tmp60_AST_in = (AST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					t2=type(_t);
					_t = _retTree;
					_t = __t12;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						returnVar = t1.getALU(t2,
						exprSymTab.getWordSize())
						.getResultType();   
						
					}
				}
				else if ((_t.getType()==MINUS)) {
					AST __t13 = _t;
					AST tmp61_AST_in = (AST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					t1=type(_t);
					_t = _retTree;
					_t = __t13;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						returnVar = t1;
						
					}
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return returnVar;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ADDRESS_OF",
		"ARG_LIST",
		"CAST",
		"COND_EXPR",
		"EXPR_LIST",
		"FUNC_CALL",
		"MEMORY",
		"MEMBER",
		"SIZEOF",
		"INDEX",
		"SLICE",
		"ARITHMETIC_PLUS",
		"ARITHMETIC_MINUS",
		"PREINCREMENT",
		"PREDECREMENT",
		"POSTINCREMENT",
		"POSTDECREMENT",
		"COMMA",
		"ASSIGNEQUAL",
		"TIMESEQUAL",
		"DIVIDEEQUAL",
		"MINUSEQUAL",
		"PLUSEQUAL",
		"MODEQUAL",
		"SHIFTLEFTEQUAL",
		"SHIFTRIGHTEQUAL",
		"BITWISEANDEQUAL",
		"BITWISEXOREQUAL",
		"BITWISEOREQUAL",
		"SEMICOLON",
		"RPAREN",
		"QUESTIONMARK",
		"COLON",
		"OR",
		"AND",
		"BITWISEOR",
		"BITWISEXOR",
		"AMPERSAND",
		"NOTEQUAL",
		"EQUAL",
		"LESSTHAN",
		"GREATERTHAN",
		"LESSTHANOREQUALTO",
		"GREATERTHANOREQUALTO",
		"SHIFTLEFT",
		"SHIFTRIGHT",
		"PLUS",
		"MINUS",
		"STAR",
		"DIVIDE",
		"MOD",
		"DOTSTAR",
		"POINTERSTAR",
		"\"sizeof\"",
		"PLUSPLUS",
		"MINUSMINUS",
		"TILDE",
		"NOT",
		"LPAREN",
		"DOT",
		"IDENT_TAB",
		"IDENT",
		"POINTERTO",
		"LSQUARE",
		"RSQUARE",
		"SCOPE",
		"\"this\"",
		"\"boolean\"",
		"\"char\"",
		"\"byte\"",
		"\"short\"",
		"\"int\"",
		"\"long\"",
		"\"float\"",
		"\"double\"",
		"OCTALINT",
		"DECIMALINT",
		"HEXADECIMALINT",
		"CharLiteral",
		"StringLiteral",
		"FLOAT",
		"DOUBLE",
		"\"true\"",
		"\"false\"",
		"\"operator\"",
		"AT",
		"ETX",
		"LCURLY",
		"RCURLY",
		"ELLIPSIS",
		"NL",
		"WS",
		"Escape",
		"Digit",
		"Decimal",
		"LongSuffix",
		"UnsignedSuffix",
		"FloatSuffix",
		"Exponent",
		"Vocabulary",
		"NUM",
		"HEX_DIGIT",
		"EXPONENT",
		"FLOAT_SUFFIX",
		"TAB_IDENT"
	};
	
	}
	
