// This file is part of the program FRYSK.
//
// Copyright 2007, 2008, Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.

package lib.unwind;

import frysk.rsl.Log;
import frysk.rsl.LogFactory;

public class UnwindPPC64 extends Unwind {
    static final Log fine = LogFactory.fine(Unwind.class);
    static final Log finest = LogFactory.finest(Unwind.class);
  
    native long createCursor(AddressSpace addressSpace,
			       long unwAddressSpace);
    native void destroyCursor(long unwCursor);
     
    native long createAddressSpace (ByteOrder byteOrder);
    native void destroyAddressSpace (long unwAddressSpace);
  
    native void setCachingPolicy(long unwAddressSpace, 
				   CachingPolicy cachingPolicy);
  
    native int isSignalFrame (long unwCursor);
  
    native int step (long unwCursor);
  
    native void getRegister(long unwCursor, Number regNum,
			      long offset, int length, byte[] word, int start);
    native void setRegister(long unwCursor, Number regNum,
			      long offset, int length, byte[] word, int start);
  
    native long getIP(long unwCursor);
    native long getSP(long unwCursor);
    native long getCFA(long unwCursor);
  
    native long copyCursor(long unwCursor);  
    native int getContext(long context);
 
    native int fillProcInfoNotAvailable(long unwProcInfo);
    native int fillProcInfoFromElfImage(long unwProcInfo,
 					  long ip, boolean needUnwindInfo,
 					  AddressSpace addressSpace,
 					  String name,
 					  long addressLow, long addressHigh,
 					  long offset);
    native int fillProcInfoFromVDSO(long unwProcInfo,
 				      long ip, boolean needUnwindInfo,
 				      AddressSpace addressSpace, 
 				      long addressLow, long addressHigh, 
 				      long offset);
    
    native long getProcInfo(long unwCursor);
    native void destroyProcInfo(long unwProcInfo);

    native long getStartIP(long unwProcInfo);
    native long getEndIP(long unwProcInfo);
    native long getLSDA(long unwProcInfo);
    native long getHandler(long unwProcInfo);
    native long getGP(long unwProcInfo);
    native long getFlags(long unwProcInfo);
    native int getFormat(long unwProcInfo);
    native int getUnwindInfoSize(long unwProcInfo);
    native long getUnwindInfo(long unwProcInfo);
}
